--[[
	Thank you for trying out 'Wan-Wan!' (Bow-Wow!)!
	
	Feel free to let me know of any bugs or other errors via comments on the
	Curse website (where you would have obtained this AddOn). Please make
	sure you post the whole error message. I will get it fixed as soon as I can.
	
	Organization: (Refer to the list below to quickly jump to different sections.)
	-Functions
	-Miscellaneous
]]

-- Functions:

function WanWan_BattleCount_Inc()
	WanWan_BattleCount = WanWan_BattleCount +1;
	if(WanWan_BattleCount >= WanWan_BattleCount_Max) then
		WanWan_IsBattleReady = true;
		WanWan_BattleCount = nil;
	end
end

function WanWan_Count_Inc()
	WanWan_Count = WanWan_Count + 1;
	if(WanWan_Count >= WanWan_Count_Max) then
		WanWan_IsReady = true;
		WanWan_Count = nil;
	end
end

function WanWan_OnEvent(self, event, ...)
	if(event == "ADDON_LOADED") then
		arg1 = ...;
		if(arg1 == "WanWan") then
			WanWan_IsOn = WanWan_IsOn_save;
			WanWan_Count_Max = WanWan_Count_Max_save or 60;
			WanWan_BattleCount_Max = WanWan_BattleCount_Max_save or 60;
			WanWan_Spam = WanWan_Spam_save;
			if(WanWan_Spam) then
				print("|cff22b14cWan-Wan!|r has been loaded. Type \"|cff22b14c/wanwan|r\" or \"|cff22b14c/bowwow|r\" to toggle it on or off.");
			end
		end
	elseif(event == "PLAYER_LOGOUT") then
		WanWan_IsOn_save = WanWan_IsOn;
		WanWan_Count_Max_save = WanWan_Count_Max;
		WanWan_BattleCount_Max_save = WanWan_BattleCount_Max;
		WanWan_Spam_save = WanWan_Spam;
	else
		if(WanWan_IsOn) then
			WanWan_GlyphEnabled_Orca, WanWan_GlyphEnabled_Cheetah = false, false;
			for i = 1, NUM_GLYPH_SLOTS do
				local Enabled, SpellID = select(1, GetGlyphSocketInfo(i)), select(4, GetGlyphSocketInfo(i));
				local Name = select(1, GetSpellInfo(SpellID));
				if(Name == "Glyph of the Cheetah") then
					WanWan_GlyphEnabled_Cheetah = true;
				elseif(Name == "Glyph of the Orca") then
					WanWan_GlyphEnabled_Orca = true;
				end
			end
			if((event == "PLAYER_ENTER_COMBAT") and (WanWan_IsBattleReady)) then
				if(UnitBuff("player", "Aquatic Form")) then
					if(WanWan_GlyphEnabled_Orca) then
						PlaySoundFile(WanWan_Sounds["Orca Form"]["Aggro"]);
					else
						PlaySoundFile(WanWan_Sounds["Aquatic Form"]["Aggro"]);
					end
				elseif(UnitBuff("player", "Travel Form")) then
					if(WanWan_GlyphEnabled_Cheetah) then
						PlaySoundFile(WanWan_Sounds["Cat Form"]["Aggro"]);
					else
						PlaySoundFile(WanWan_Sounds["Travel Form"]["Aggro"]);
					end
				elseif(UnitBuff("player", "Bear Form")) then
					PlaySoundFile(WanWan_Sounds["Bear Form"]["Aggro"]);
				elseif(UnitBuff("player", "Cat Form")) then
					PlaySoundFile(WanWan_Sounds["Cat Form"]["Aggro"]);
				elseif(UnitBuff("player", "Ghost Wolf")) then
					PlaySoundFile(WanWan_Sounds["Ghost Wolf"]["Aggro"]);
				end
				WanWan_IsBattleReady = false;
				WanWan_BattleCount = 1;
			elseif(event == "PLAYER_REGEN_ENABLED") then
				WanWan_IsBattleReady = true;
			else
				if((WanWan_IsReady) and ((event == "AUCTION_HOUSE_SHOW") or (event == "BANKFRAME_OPENED") or (event == "BATTLEFIELDS_SHOW") or (event == "FORGE_MASTER_OPENED") or (event == "GOSSIP_SHOW") or (event == "LFG_OPEN_FROM_GOSSIP") or (event == "MERCHANT_SHOW") or (event == "QUEST_GREETING") or (event == "TAXIMAP_OPENED") or (event == "TRAINER_SHOW"))) then
					if(UnitBuff("player", "Aquatic Form")) then
						x = math.random(1, 4);
						if(WanWan_GlyphEnabled_Orca) then
							PlaySoundFile(WanWan_Sounds["Orca Form"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Aquatic Form"][x]);
						end
					elseif(UnitBuff("player", "Travel Form")) then
						x = math.random(1, 4);
						if(WanWan_GlyphEnabled_Cheetah) then
							PlaySoundFile(WanWan_Sounds["Cat Form"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Travel Form"][x]);
						end
					elseif(UnitBuff("player", "Bear Form")) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Bear Form"][x]);
					elseif(UnitBuff("player", "Cat Form")) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Cat Form"][x]);
					elseif((UnitBuff("player", "Flight Form") or (UnitBuff("player", "Swift Flight Form")))) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Flight Form"][x]);
					elseif(UnitBuff("player", "Ghost Wolf")) then
						x = math.random(1, 6);
						PlaySoundFile(WanWan_Sounds["Ghost Wolf"][x]);
					end
					WanWan_IsReady = false;
					WanWan_Count = 1;
				end
			end
		end
	end
end

function WanWan_Frame_OnLoad(self)
	WanWan_Frame:RegisterEvent("ADDON_LOADED");
	WanWan_Frame:RegisterEvent("PLAYER_LOGOUT");
	
	WanWan_Frame:RegisterEvent("PLAYER_ENTER_COMBAT");
	WanWan_Frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	WanWan_Frame:RegisterEvent("AUCTION_HOUSE_SHOW");
	WanWan_Frame:RegisterEvent("BANKFRAME_OPENED");
	WanWan_Frame:RegisterEvent("BATTLEFIELDS_SHOW");
	WanWan_Frame:RegisterEvent("FORGE_MASTER_OPENED");
	WanWan_Frame:RegisterEvent("GOSSIP_SHOW");
	WanWan_Frame:RegisterEvent("LFG_OPEN_FROM_GOSSIP");
	WanWan_Frame:RegisterEvent("MERCHANT_SHOW");
	WanWan_Frame:RegisterEvent("QUEST_GREETING");
	WanWan_Frame:RegisterEvent("TAXIMAP_OPENED");
	WanWan_Frame:RegisterEvent("TRAINER_SHOW");
	
	WanWan_Frame:SetScript("OnEvent", WanWan_OnEvent);
	WanWan_Frame:SetScript("OnUpdate", WanWan_OnUpdate);
	
	SlashCmdList["WANWAN_MENU"] = WanWan_Menu;
	SLASH_WANWAN_MENU1 = "/wanwan";
	SLASH_WANWAN_MENU2 = "/bowwow";
	
	WanWan_IsReady = true; 
	WanWan_IsBattleReady = true;
	WanWan_Count = nil;
	WanWan_BattleCount = nil;
	
	WanWan_Sounds = {
		["Bear Form"] = {
			[1] = "Sound\\Creature\\Bear\\mBearAttackA.ogg",
			[2] = "Sound\\Creature\\Bear\\mBearAttackB.ogg",
			[3] = "Sound\\Creature\\Bear\\mBearAttackD.ogg",
			[4] = "Sound\\Creature\\Bear\\mBearAttackCriticalA.ogg",
			["Aggro"] = "Sound\\Creature\\Bear\\mBearAggroA.ogg",
		},
		["Cat Form"] = {
			[1] = "Sound\\Creature\\Tiger\\mTigerAttackA.ogg",
			[2] = "Sound\\Creature\\Tiger\\mTigerAttackB.ogg",
			[3] = "Sound\\Creature\\Tiger\\mTigerAttackC.ogg",
			[4] = "Sound\\Creature\\Tiger\\mTigerAttackD.ogg",
			["Aggro"] = "Sound\\Creature\\Tiger\\mTigerDeathA.ogg",
		},
		["Aquatic Form"] = {
			[1] = "Sound\\Creature\\Walrus\\WalrusAttackA.ogg",
			[2] = "Sound\\Creature\\Walrus\\WalrusAttackB.ogg",
			[3] = "Sound\\Creature\\Walrus\\WalrusAttackC.ogg",
			[4] = "Sound\\Creature\\Walrus\\WalrusPreAggro.ogg",
			["Aggro"] = "Sound\\Creature\\Walrus\\WalrusAggroA.ogg",
		},
		["Orca Form"] = {
			[1] = "Sound\\Creature\\ORca\\OrcaAttackA.ogg",
			[2] = "Sound\\Creature\\ORca\\OrcaAttackB.ogg",
			[3] = "Sound\\Creature\\ORca\\OrcaAttackC.ogg",
			[4] = "Sound\\Creature\\ORca\\OrcaPreAggro.ogg",
			["Aggro"] = "Sound\\Creature\\ORca\\OrcaAggro.ogg",
		},
		["Travel Form"] = {
			[1] = "Sound\\Creature\\Giraffe\\GiraffeAttackA.ogg",
			[2] = "Sound\\Creature\\Giraffe\\GiraffeAttackB.ogg",
			[3] = "Sound\\Creature\\Giraffe\\GiraffeAttackC.ogg",
			[4] = "Sound\\Creature\\Giraffe\\GiraffePreAggroA.ogg",
			["Aggro"] = "Sound\\Creature\\Giraffe\\GiraffeAggroA.ogg",
		},
		["Flight Form"] = {
			[1] = "Sound\\Creature\\StormCrow\\StormCrowAttackA.ogg",
			[2] = "Sound\\Creature\\StormCrow\\StormCrowAttackB.ogg",
			[3] = "Sound\\Creature\\StormCrow\\StormCrowAttackC.ogg",
			[4] = "Sound\\Creature\\StormCrow\\StormCrowPreAggro.ogg",
		},
		["Ghost Wolf"] = {
			[1] = "Sound\\Creature\\Wolf\\mWolfAttack1.ogg",
			[2] = "Sound\\Creature\\Wolf\\mWolfAttack2.ogg",
			[3] = "Sound\\Creature\\Wolf\\mWolfAttack3.ogg",
			[4] = "Sound\\Creature\\Wolf\\mWolfAttack4.ogg",
			[5] = "Sound\\Creature\\Wolf\\mWolfAttack5.ogg",
			[6] = "Sound\\Creature\\Wolf\\mWolfAttack6.ogg",
			["Aggro"] = "Sound\\Creature\\Wolf\\mWolfAggro3.ogg",
		},
	};
end

function WanWan_Help()
	print("|cff22b14cWan-Wan!|r slash-commands:");
	print("\"|cff22b14c/wanwan|r\" --> Toggle the extra sounds made in feral form on or off");
	print("\"|cff22b14c/wanwan spam|r\" --> Toggle the login greeting on or off");
	print("\"|cff22b14c/wanwan x|r\" --> Adjust how long you want the AddOn to wait when making extra sounds (x must be between 1 and 1000, inclusive)");
	print("\"|cff22b14c/wanwan ?|r\" --> Display these messages");
end

function WanWan_Menu(msg)
	if(msg == "") then
		-- No message, technically. Toggle 'WanWan_IsOn' variable.
		WanWan_Toggle();
	elseif(msg == "spam") then
		-- 'spam' message. Toggle the login spam message.
		WanWan_Spam_Toggle();
	elseif((msg == "?") or (msg == "help")) then
		-- '?' or 'help' message. Spam the different slash command options.
		WanWan_Help();
	elseif(type(msg) == "number") then
		-- Number message. If valid, set the WanWan_Count_Max and WanWan_BattleCount_Max to that number.
		WanWan_Set_Count_Max(msg);
	else
		print("|cff800000Error:|r No valid slash-command option was found. Type \"|cff22b14c/wanwan ?|r\" if you need to see a list.");
	end
end

function WanWan_OnUpdate()
	if(WanWan_Count) then
		-- Watching the regular count. Go to WanWan_Count_Inc function.
		WanWan_Count_Inc();
	elseif(WanWan_BattleCount) then
		-- Watching the in-combat count. Go to WanWan_BattleCount_Inc function.
		WanWan_BattleCount_Inc();
	end
end

function WanWan_Set_Count_Max(x)
	if((x > 0) and (x <= 1000)) then
		-- x must be between 1 and 1000, inclusive.
		WanWan_Count_Max = x;
		WanWan_BattleCount_Max = x;
	else
		-- Invalid number used. Print error message.
		print("|cff800000Error:|r When setting the |cff22b14cWanWan_Count_Max|r variable, please use a valid number between 1 and 1000, inclusive.");
	end
end

function WanWan_Spam_Toggle()
	WanWan_Spam = not WanWan_Spam;
	if(WanWan_Spam) then
		print("|cff22b14cWan-Wan!|r greeting |cff008000enabled|r.");
	else
		print("|cff22b14cWan-Wan!|r greeting |cff800000disabled|r.");
	end
end

function WanWan_Toggle()
	WanWan_IsOn = not WanWan_IsOn;
	if(WanWan_IsOn) then
		WanWan_Count = nil;
		WanWan_BattleCount = nil;
		WanWan_IsReady = true;
		WanWan_IsBattleReady = true;
		print("|cff22b14cWan-Wan!|r is |cff008000enabled|r. You will make extra sounds in feral form.");
	else
		WanWan_Count = nil;
		WanWan_BattleCount = nil;
		WanWan_IsReady = false;
		WanWan_IsBattleReady = false;
		print("|cff22b14cWan-Wan!|r is |cff800000disabled|r. You will not make extra sounds in feral form.");
	end
end


-- Miscellaneous:

--[[
Special Thanks:
	*My family and friends for their support.
	*The WoW community (both in-game and in-forum) for the inspiration,  advice, and support.
	*You, the AddOn user, for testing out my idea!
]]